diff -uwr source/scripts/tcw_player.cpp 4.0/source/scripts/tcw_player.cpp
--- source/scripts/tcw_player.cpp	2011-09-03 08:30:06.000000000 +0800
+++ 4.0/source/scripts/tcw_player.cpp	2011-10-15 12:39:38.266601500 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -15,17 +15,212 @@
 #include "scripts.h"
 #include "engine.h"
 #include "tcw_player.h"
+#ifdef SSGM
+#include "gmgame.h"
+#endif
 
 
-void tcw_Grant_Powerup_Created::Created(GameObject *obj)
+void tcw_Grant_Powerup_Created::Created(GameObject *obj)//with this script we can do to players what we want easily
 {
-	//with this script we can do to players what we want easily
-	int sniperlimit = 2;
+	map_low_grav = false;	map_dm_tech1 = false;	map_dm_tech2 = false;	map_dm_tech3 = false;	map_coop_gdi = false;	map_coop_nod = false;	
+	if (Find_Object_By_Preset(2,"TCW_Low_Grav_Map")) { map_low_grav = true; }
+	if (Find_Object_By_Preset(2,"TCW_DM_Tech1")) { map_dm_tech1 = true; }//no snipers, shadows and commando's
+	if (Find_Object_By_Preset(2,"TCW_DM_Tech2")) { map_dm_tech2 = true; }//no commando's
+	if (Find_Object_By_Preset(2,"TCW_DM_Tech3")) { map_dm_tech3 = true; }//no limitations
+	if (Find_Object_By_Preset(2,"TCW_Coop_Map_GDI")) { map_coop_gdi = true; }
+	if (Find_Object_By_Preset(2,"TCW_Coop_Map_Nod")) { map_coop_nod = true; }
+
+	if (map_coop_nod)
+	{
+		if (Commands->Get_Player_Type(obj) == 1)	{ Change_Team(obj,0); }
+	}
+	else if (map_coop_gdi)
+	{
+		if (Commands->Get_Player_Type(obj) == 0)	{ Change_Team(obj,1); }
+	}
+
+	if (map_dm_tech1)
+	{
+		int randomchargdi = Commands->Get_Random_Int(1,5);		int randomcharnod = Commands->Get_Random_Int(1,5);
+		if (map_low_grav)
+		{
+			if (Commands->Get_Player_Type(obj) == 1)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_GDI_Rifle_Squad_Low"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_GDI_Engineer_Low"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_GDI_Grenadier_Low"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_GDI_Missile_Squad_Low"); }
+					else								{ Change_Character(obj,"TCW_GDI_Zonetrooper_Low"); }
+				}
+			}
+			else if (Commands->Get_Player_Type(obj) == 0)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Minigunner_0") == 0)
+				{
+					if (randomcharnod == 1)				{ Change_Character(obj,"TCW_Nod_Militant_Infantry_Low"); }
+					else if (randomcharnod == 2)		{ Change_Character(obj,"TCW_Black_Hand_Low"); }
+					else if (randomcharnod == 3)		{ Change_Character(obj,"TCW_Nod_RocketGuy_Low"); }
+					else if (randomcharnod == 4)		{ Change_Character(obj,"TCW_Nod_Saboteur_Low"); }
+					else								{ Change_Character(obj,"TCW_Nod_Militant_Infantry_Low"); }
+				}
+			}
+		}
+		else
+		{
+			if (Commands->Get_Player_Type(obj) == 1)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_GDI_Rifle_Squad"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_GDI_Engineer"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_GDI_Grenadier"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_GDI_Missile_Squad"); }
+					else								{ Change_Character(obj,"TCW_GDI_Zonetrooper"); }
+				}
+			}
+			else if (Commands->Get_Player_Type(obj) == 0)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Minigunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_Nod_Militant_Infantry"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_Nod_Black_Hand_Flame"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_Nod_RocketGuy"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_Nod_Saboteur"); }
+					else								{ Change_Character(obj,"TCW_Nod_Militant_Infantry"); }
+				}
+			}
+		}
+	}
+	else if (map_dm_tech2)
+	{
+		int randomchargdi = Commands->Get_Random_Int(1,6);		int randomcharnod = Commands->Get_Random_Int(1,6);
+		if (map_low_grav)
+		{
+			if (Commands->Get_Player_Type(obj) == 1)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_GDI_Rifle_Squad_Low"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_GDI_Engineer_Low"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_GDI_Grenadier_Low"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_GDI_Missile_Squad_Low"); }
+					else if (randomchargdi == 5)		{ Change_Character(obj,"TCW_GDI_Sniper_Low"); }
+					else								{ Change_Character(obj,"TCW_GDI_Zonetrooper_Low"); }
+				}
+			}
+			else if (Commands->Get_Player_Type(obj) == 0)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Minigunner_0") == 0)
+				{
+					if (randomcharnod == 1)				{ Change_Character(obj,"TCW_Nod_Militant_Infantry_Low"); }
+					else if (randomcharnod == 2)		{ Change_Character(obj,"TCW_Black_Hand_Low"); }
+					else if (randomcharnod == 3)		{ Change_Character(obj,"TCW_Nod_RocketGuy_Low"); }
+					else if (randomcharnod == 4)		{ Change_Character(obj,"TCW_Nod_Saboteur_Low"); }
+					else if (randomcharnod == 5)		{ Change_Character(obj,"TCW_Nod_Shadow_Low"); }
+					else								{ Change_Character(obj,"TCW_Nod_Militant_Infantry_Low"); }
+				}
+			}
+		}
+		else
+		{
+			if (Commands->Get_Player_Type(obj) == 1)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_GDI_Rifle_Squad"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_GDI_Engineer"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_GDI_Grenadier"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_GDI_Missile_Squad"); }
+					else if (randomchargdi == 5)		{ Change_Character(obj,"TCW_GDI_Sniper"); }
+					else								{ Change_Character(obj,"TCW_GDI_Zonetrooper"); }
+				}
+			}
+			else if (Commands->Get_Player_Type(obj) == 0)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Minigunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_Nod_Militant_Infantry"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_Nod_Black_Hand_Flame"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_Nod_RocketGuy"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_Nod_Saboteur"); }
+					else if (randomchargdi == 5)		{ Change_Character(obj,"TCW_Nod_Shadow"); }
+					else								{ Change_Character(obj,"TCW_Nod_Militant_Infantry"); }
+				}
+			}
+		}
+	}
+	else if (map_dm_tech3)
+	{
+		int randomchargdi = Commands->Get_Random_Int(1,7);		int randomcharnod = Commands->Get_Random_Int(1,7);
+		if (map_low_grav)
+		{
+			if (Commands->Get_Player_Type(obj) == 1)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_GDI_Rifle_Squad_Low"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_GDI_Engineer_Low"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_GDI_Grenadier_Low"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_GDI_Missile_Squad_Low"); }
+					else if (randomchargdi == 5)		{ Change_Character(obj,"TCW_GDI_Sniper_Low"); }
+					else if (randomchargdi == 6)		{ Change_Character(obj,"TCW_GDI_Commando_Low"); }
+					else								{ Change_Character(obj,"TCW_GDI_Zonetrooper_Low"); }
+				}
+			}
+			else if (Commands->Get_Player_Type(obj) == 0)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Minigunner_0") == 0)
+				{
+					if (randomcharnod == 1)				{ Change_Character(obj,"TCW_Nod_Militant_Infantry_Low"); }
+					else if (randomcharnod == 2)		{ Change_Character(obj,"TCW_Black_Hand_Low"); }
+					else if (randomcharnod == 3)		{ Change_Character(obj,"TCW_Nod_RocketGuy_Low"); }
+					else if (randomcharnod == 4)		{ Change_Character(obj,"TCW_Nod_Saboteur_Low"); }
+					else if (randomcharnod == 5)		{ Change_Character(obj,"TCW_Nod_Shadow_Low"); }
+					else if (randomcharnod == 6)		{ Change_Character(obj,"TCW_Nod_Commando_Low"); }
+					else								{ Change_Character(obj,"TCW_Nod_Militant_Infantry_Low"); }
+				}
+			}
+		}
+		else
+		{
+			if (Commands->Get_Player_Type(obj) == 1)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_GDI_Rifle_Squad"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_GDI_Engineer"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_GDI_Grenadier"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_GDI_Missile_Squad"); }
+					else if (randomchargdi == 5)		{ Change_Character(obj,"TCW_GDI_Sniper"); }
+					else if (randomchargdi == 6)		{ Change_Character(obj,"TCW_GDI_Commando"); }
+					else								{ Change_Character(obj,"TCW_GDI_Zonetrooper"); }
+				}
+			}
+			else if (Commands->Get_Player_Type(obj) == 0)
+			{
+				if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Minigunner_0") == 0)
+				{
+					if (randomchargdi == 1)				{ Change_Character(obj,"TCW_Nod_Militant_Infantry"); }
+					else if (randomchargdi == 2)		{ Change_Character(obj,"TCW_Nod_Black_Hand_Flame"); }
+					else if (randomchargdi == 3)		{ Change_Character(obj,"TCW_Nod_RocketGuy"); }
+					else if (randomchargdi == 4)		{ Change_Character(obj,"TCW_Nod_Saboteur"); }
+					else if (randomchargdi == 5)		{ Change_Character(obj,"TCW_Nod_Shadow"); }
+					else if (randomchargdi == 6)		{ Change_Character(obj,"TCW_Nod_Commando"); }
+					else								{ Change_Character(obj,"TCW_Nod_Militant_Infantry"); }
+				}
+			}
+		}
+	}
+
+	Commands->Start_Timer(obj,this,1.5f,1003);//give MapCredits
 
 	upgrade_composit_armor_available = false;
 	if (Find_Object_By_Preset(2,"TCW_Tech_Composit_Armor_Available")) {	upgrade_composit_armor_available = true; }
 
-	int random = Commands->Get_Random_Int(1,3);//used by char purchase playsound
+	int sniperlimit = 2;
+
 	commandocurrpos.X = 0;	commandocurrpos.Y = 0;	commandocurrpos.Z = 0;
 	commandonewpos.X = 0;	commandonewpos.Y = 0;	commandonewpos.Z = 0;
 	revealed = false;
@@ -38,6 +233,12 @@
 		commandocurrpos = Commands->Get_Position(obj);
 		Commands->Start_Timer(obj,this,1.0f,1006);//check move enable stealth
 	}
+	else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Sniper") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Sniper_Low") == 0) )
+	{
+		Commands->Enable_Stealth(obj,true);
+		commandocurrpos = Commands->Get_Position(obj);
+		Commands->Start_Timer(obj,this,1.0f,1006);//check move enable stealth
+	}
 
 	//grant weapon stuff when they spawn
 	const char *weapon1 = Get_Parameter("Weapon1");	const char *weapon2 = Get_Parameter("Weapon2");	const char *weapon3 = Get_Parameter("Weapon3");	const char *weapon4 = Get_Parameter("Weapon4");	const char *weapon5 = Get_Parameter("Weapon5");
@@ -47,26 +248,19 @@
 	if (_stricmp(weapon4,"0") != 0)	{ Commands->Give_PowerUp(obj,weapon4,false); }
 	if (_stricmp(weapon5,"0") != 0)	{ Commands->Give_PowerUp(obj,weapon5,false); }
 
-	//commandocheck
+	//unit purchase sounds
+	int random = Commands->Get_Random_Int(1,3);//used by char purchase playsound
 	if (Commands->Get_Player_Type(obj) == 1)
 	{
 		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Commando") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Commando_Low") == 0) )
 		{
 			if ( (Get_Object_Count(1,"TCW_GDI_Commando") > 1) || (Get_Object_Count(1,"TCW_GDI_Commando_Low") > 1) )
 			{
-				if (Is_Base_Powered(1))
-				{
 					Commands->Give_Money(obj,2000.0f,false);
 					Change_Character(obj,"CnC_GDI_MiniGunner_0");
 				}
 				else
 				{
-					Commands->Give_Money(obj,4000.0f,false);
-					Change_Character(obj,"CnC_GDI_MiniGunner_0");
-				}
-			}
-			else
-			{
 				Create_2D_WAV_Sound_Team("nod_commandodetected.wav",0);
 				Send_Message_Team(0,255,0,0,"Warning, enemy commando detected.");
 
@@ -74,27 +268,32 @@
 				if (rnd == 1)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_commando_1.wav",1);
-					Send_Message_Team(1,255,204,0,"Got a present for ya.");
+					char player[250]; sprintf(player,"%s: Got a present for ya.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
 				}
 				else if (rnd == 2)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_commando_2.wav",1);
-					Send_Message_Team(1,255,204,0,"Okay boss let's hear the plan.");
+					char player[250]; sprintf(player,"%s: Okay boss let's hear the plan.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
 				}
 				else if (rnd == 3)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_commando_3.wav",1);
-					Send_Message_Team(1,255,204,0,"Let's get this party started.");
+					char player[250]; sprintf(player,"%s: Let's get this party started.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
 				}
 				else if (rnd == 4)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_commando_4.wav",1);
-					Send_Message_Team(1,255,204,0,"Didn't miss anything, did i?.");
+					char player[250]; sprintf(player,"%s: Didn't miss anything, did i?.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
 				}
 				else if (rnd == 5)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_commando_5.wav",1);
-					Send_Message_Team(1,255,204,0,"Let's load and lock and roll and rock.");
+					char player[250]; sprintf(player,"%s: Let's load and lock and roll and rock.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
 				}
 			}
 		}
@@ -104,17 +303,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Keep your weapon ready.");
+				char player[250]; sprintf(player,"%s: Keep your weapon ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_2.wav",1);
-				Send_Message_Team(1,255,204,0,"Rifle squad ready.");
+				char player[250]; sprintf(player,"%s: Rifle squad ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_3.wav",1);
-				Send_Message_Team(1,255,204,0,"Rifleman awaiting orders.");
+				char player[250]; sprintf(player,"%s: Rifleman awaiting orders.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			if (upgrade_composit_armor_available)
 			{
@@ -127,17 +329,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Keep your weapon ready.");
+				char player[250]; sprintf(player,"%s: Keep your weapon ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_2.wav",1);
-				Send_Message_Team(1,255,204,0,"Rifle squad ready.");
+				char player[250]; sprintf(player,"%s: Rifle squad ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_3.wav",1);
-				Send_Message_Team(1,255,204,0,"Rifleman awaiting orders.");
+				char player[250]; sprintf(player,"%s: Rifleman awaiting orders.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			if (upgrade_composit_armor_available)
 			{
@@ -150,17 +355,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_engineer_1.wav",1);
-				Send_Message_Team(1,255,204,0,"I got their codes.");
+				char player[250]; sprintf(player,"%s: I got their codes.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_engineer_2.wav",1);
-				Send_Message_Team(1,255,204,0,"Engineer clocking in.");
+				char player[250]; sprintf(player,"%s: Engineer clocking in.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_engineer_3.wav",1);
-				Send_Message_Team(1,255,204,0,"Engineer reporting in.");
+				char player[250]; sprintf(player,"%s: Engineer reporting in.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 		}
 		else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Grenadier") == 0)
@@ -168,17 +376,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_1.wav",1);
-				Send_Message_Team(1,255,204,0,"They won't be coming back out.");
+				char player[250]; sprintf(player,"%s: They won't be coming back out.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_2.wav",1);
-				Send_Message_Team(1,255,204,0,"Somebody call for some blasting?");
+				char player[250]; sprintf(player,"%s: Somebody call for some blasting?",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_3.wav",1);
-				Send_Message_Team(1,255,204,0,"Grenade squad all ready.");
+				char player[250]; sprintf(player,"%s: Grenade squad all ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			if (upgrade_composit_armor_available)
 			{
@@ -190,17 +401,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_1.wav",1);
-				Send_Message_Team(1,255,204,0,"They won't be coming back out.");
+				char player[250]; sprintf(player,"%s: They won't be coming back out.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_2.wav",1);
-				Send_Message_Team(1,255,204,0,"Somebody call for some blasting?");
+				char player[250]; sprintf(player,"%s: Somebody call for some blasting?",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_grenadier_3.wav",1);
-				Send_Message_Team(1,255,204,0,"Grenade squad all ready.");
+				char player[250]; sprintf(player,"%s: Grenade squad all ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			if (upgrade_composit_armor_available)
 			{
@@ -208,24 +422,25 @@
 			}
 		}		
 
-
-
 		else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Missile_Squad") == 0)
 		{
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Launcher's ready.");
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Launcher's ready.");
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Launcher's ready.");
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			if (upgrade_composit_armor_available)
 			{
@@ -237,17 +452,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Launcher's ready.");
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Launcher's ready.");
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_missile_squad_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Launcher's ready.");
+				char player[250]; sprintf(player,"%s: Launcher's ready.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			if (upgrade_composit_armor_available)
 			{
@@ -279,17 +497,20 @@
 				if (random == 1)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_1.wav",1);
-					Send_Message_Team(1,255,204,0,"Take 'em out one by one.");
+					char player[250]; sprintf(player,"%s: Take 'em out one by one.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
 				}
 				else if (random == 2)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_2.wav",1);
-					Send_Message_Team(1,255,204,0,"Sniper team ready.");
+					char player[250]; sprintf(player,"%s: Sniper team ready.",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
 				}
 				else if (random == 3)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_3.wav",1);
-					Send_Message_Team(1,255,204,0,"Sniper team, where do you need us?");
+					char player[250]; sprintf(player,"%s: Sniper team, where do you need us?",Get_Player_Name(obj));
+					Send_Message_Team(1,255,204,0,player);
 				}
 			}
 		}
@@ -298,17 +519,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_1.wav",1);
-				Send_Message_Team(1,255,204,0,"Keep 'em coming.");
+				char player[250]; sprintf(player,"%s: Keep 'em coming.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_2.wav",1);
-				Send_Message_Team(1,255,204,0,"Troopers ready for action.");
+				char player[250]; sprintf(player,"%s: Troopers ready for action.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_3.wav",1);
-				Send_Message_Team(1,255,204,0,"Troopers in the field.");
+				char player[250]; sprintf(player,"%s: Troopers in the field.",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,player);
 			}
 		}
 	}
@@ -329,17 +553,20 @@
 				if (random == 1)
 				{
 					Create_2D_WAV_Sound_Team("purchase_nod_commando_1.wav",0);
-					Send_Message_Team(0,255,0,0,"Nice day for a kill.");
+					char player[250]; sprintf(player,"%s: Nice day for a kill.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
 				}
 				else if (random == 2)
 				{
-					Create_2D_WAV_Sound_Team("purchase_nod_commando_1.wav",0);
-					Send_Message_Team(0,255,0,0,"Nice day for a kill.");
+					Create_2D_WAV_Sound_Team("purchase_nod_commando_2.wav",0);
+					char player[250]; sprintf(player,"%s: Ready for assignment.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
 				}
 				else if (random == 3)
 				{
 					Create_2D_WAV_Sound_Team("purchase_nod_commando_2.wav",0);
-					Send_Message_Team(0,255,0,0,"Ready for assignment.");
+					char player[250]; sprintf(player,"%s: Ready for assignment.",Get_Player_Name(obj));
+					Send_Message_Team(0,255,0,0,player);
 				}
 			}
 		}
@@ -348,17 +575,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_1.wav",0);
-				Send_Message_Team(0,255,0,0,"Rise up.");
+				char player[250]; sprintf(player,"%s: Rise up.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_2.wav",0);
-				Send_Message_Team(0,255,0,0,"The time has come warrior of Nod.");
+				char player[250]; sprintf(player,"%s: The time has come warrior of Nod.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_squad_3.wav",0);
-				Send_Message_Team(0,255,0,0,"Fighters arm up.");
+				char player[250]; sprintf(player,"%s: Fighters arm up.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 		}
 		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Chem") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Chem_Low") == 0) )
@@ -366,41 +596,48 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_chem_1.wav",0);
-				Send_Message_Team(0,255,0,0,"Strenght in tiberium.");
+				char player[250]; sprintf(player,"%s: Strenght in tiberium.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_chem_2.wav",0);
-				Send_Message_Team(0,255,0,0,"The Black Hand is in control.");
+				char player[250]; sprintf(player,"%s: The Black Hand is in control.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_chem_3.wav",0);
-				Send_Message_Team(0,255,0,0,"The Black Hand has arrived.");
+				char player[250]; sprintf(player,"%s: The Black Hand has arrived.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 		}
-		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Flame") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Flame_Low") == 0) )
+		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Flame") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Black_Hand_Low") == 0) )
 		{
 			int rnd = Commands->Get_Random_Int(1,4);
 			if (rnd == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_1.wav",0);
-				Send_Message_Team(0,255,0,0,"One mission. One purpose.");
+				char player[250]; sprintf(player,"%s: One mission. One purpose.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (rnd == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_2.wav",0);
-				Send_Message_Team(0,255,0,0,"Pure fire ready.");
+				char player[250]; sprintf(player,"%s: Pure fire ready.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (rnd == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_3.wav",0);
-				Send_Message_Team(0,255,0,0,"The flame shall purify.");
+				char player[250]; sprintf(player,"%s: The flame shall purify.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (rnd == 4)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_4.wav",0);
-				Send_Message_Team(0,255,0,0,"And then there was fire.");
+				char player[250]; sprintf(player,"%s: And then there was fire.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 		}
 		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_RocketGuy") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_RocketGuy_Low") == 0) )
@@ -408,17 +645,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_rocket_squad_1.wav",0);
-				Send_Message_Team(0,255,0,0,"If it moves: Kill it.");
+				char player[250]; sprintf(player,"%s: If it moves: Kill it.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_rocket_squad_2.wav",0);
-				Send_Message_Team(0,255,0,0,"Rockets ready.");
+				char player[250]; sprintf(player,"%s: Rockets ready.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_militant_rocket_squad_3.wav",0);
-				Send_Message_Team(0,255,0,0,"We got the rockets.");
+				char player[250]; sprintf(player,"%s: We got the rockets.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 		}
 		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Saboteur") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Saboteur_Low") == 0) )
@@ -426,17 +666,20 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_1.wav",0);
-				Send_Message_Team(0,255,0,0,"The Brotherhood has entrusted me.");
+				char player[250]; sprintf(player,"%s: The Brotherhood has entrusted me.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_2.wav",0);
-				Send_Message_Team(0,255,0,0,"Need help with anything?");
+				char player[250]; sprintf(player,"%s: Need help with anything?",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_saboteur_1.wav",0);
-				Send_Message_Team(0,255,0,0,"The Brotherhood has entrusted me.");
+				char player[250]; sprintf(player,"%s: The Brotherhood has entrusted me.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 		}
 		if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Shadow") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Shadow_Low") == 0) )
@@ -444,24 +687,34 @@
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_shadow_1.wav",0);
-				Send_Message_Team(0,255,0,0,"Quietly.");
+				char player[250]; sprintf(player,"%s: Quietly.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_shadow_2.wav",0);
-				Send_Message_Team(0,255,0,0,"Shadow team at your command.");
+				char player[250]; sprintf(player,"%s: Shadow team at your command.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (random == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_shadow_2.wav",0);
-				Send_Message_Team(0,255,0,0,"Shadow team at your command.");
+				char player[250]; sprintf(player,"%s: Shadow team at your command.",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,player);
 			}
 		}
 	}
 }
 void tcw_Grant_Powerup_Created::Timer_Expired(GameObject *obj, int number)
 {
-	if (number == 1004)//enable stealth again after distance check 
+	if (number == 1003)
+	{
+/*#ifdef SSGM
+	float cmoney = Commands->Get_Money(obj);
+	if (cmoney < MapCredits) { Commands->Give_Money(obj,MapCredits-cmoney,false); } //give the spawn credits everytime they spawn
+#endif*/
+	}
+	else if (number == 1004)//enable stealth again after distance check 
 	{
 		Commands->Enable_Stealth(obj, true);
 		revealed = false;
@@ -470,7 +723,7 @@
 	{
 		playdetected = true;
 	}
-	else if (number == 1006)
+	else if (number == 1006)//used for stealthing Nod Commando and GDI Sniper
 	{
 		commandonewpos = Commands->Get_Position(obj);
 		float commandotraveldistance = Commands->Get_Distance(commandocurrpos,commandonewpos);
@@ -486,7 +739,6 @@
 			Commands->Start_Timer(obj,this,1.0f,1006);
 		}
 	}
-	//1007 used by TCW_Check_Beacon_Status
 }
 void tcw_Grant_Powerup_Created::Killed(GameObject *obj, GameObject *shooter)
 {
@@ -561,6 +813,8 @@
 	{ 
 		if (param == 1)
 		{
+			if (Commands->Get_Player_Type(sender) != Commands->Get_Player_Type(obj))
+			{
 			Vector3 mypos = Commands->Get_Position(obj);
 			Vector3 target = Commands->Get_Position(sender);
 			float distance = Commands->Get_Distance(mypos,target);
